### Method

# Gio OutputStream write_all

#### Declaration

    gboolean
    g_output_stream_write_all (
      GOutputStream* stream,
      void* buffer,
      gsize count,
      gsize* bytes_written,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Tries to write `count` bytes from `buffer` into the stream. Will block during the operation.

This function is similar to g_output_stream_write(), except it tries to write as many bytes as requested, only stopping on an error.

On a successful write of `count` bytes, `TRUE` is returned, and `bytes_written` is set to `count`.

If there is an error during the operation `FALSE` is returned and `error` is set to indicate the error status.

As a special exception to the normal conventions for functions that use `GError`, if this function returns `FALSE` (and sets `error`) then `bytes_written` will be set to the number of bytes that were successfully written before the error was encountered. This functionality is only available from C. If you need it from another language then you must write your own loop around g_output_stream_write().

#### Parameters

`buffer`

  Type: An array of `guint8`

  The buffer containing the data to write.

  The length of the array is specified in the `count` argument.
  The data is owned by the caller of the method.

`count`

  Type: `gsize`

  The number of bytes to write.

`bytes_written`

  Type: `gsize*`

  Location to store the number of bytes that was written to the stream.

  The argument will be set by the function.
  The argument can be `NULL`.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` on success, `FALSE` if there was an error.